(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("lodash"));
	else if(typeof define === 'function' && define.amd)
		define(["lodash"], factory);
	else if(typeof exports === 'object')
		exports["whynomatch"] = factory(require("lodash"));
	else
		root["whynomatch"] = factory(root["_"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

	var _lodash = __webpack_require__(1);

	var _lodash2 = _interopRequireDefault(_lodash);

	var _mongo_parsing_error = __webpack_require__(2);

	var _mongo_parsing_error2 = _interopRequireDefault(_mongo_parsing_error);

	var comparisionOperators = {
	  $eq: function $eq(target, value) {
	    return target === value;
	  },
	  $gt: function $gt(target, value) {
	    return target > value;
	  },
	  $gte: function $gte(target, value) {
	    return target >= value;
	  },
	  $lt: function $lt(target, value) {
	    return target < value;
	  },
	  $lte: function $lte(target, value) {
	    return target <= value;
	  },
	  $ne: function $ne(target, value) {
	    return target !== value;
	  },
	  $exists: function $exists(target, value) {
	    return target !== undefined == value;
	  },
	  $mod: function $mod(target, value) {
	    if (!_lodash2["default"].isArray(value) || value.length !== 2) throw new _mongo_parsing_error2["default"]("mod", "array of size 2: [dividor, reminder]", value);

	    var divisor = value[0];
	    var reminder = value[1];

	    return target % divisor === reminder;
	  },
	  $regex: function $regex(target, value) {
	    if (!_lodash2["default"].isString(value) && !_lodash2["default"].isRegExp(value)) throw new _mongo_parsing_error2["default"]("regex", "RegExp or a string", value);

	    return new RegExp(value).test(target);
	  },
	  $where: function $where(target, value) {
	    var fn = undefined;

	    if (_lodash2["default"].isFunction(value)) {
	      fn = value;
	    } else if (_lodash2["default"].isString(value)) {
	      eval("fn = function(){var obj = this; return " + value + "}");
	    } else {
	      throw new _mongo_parsing_error2["default"]("where", "function or a string", value);
	    }

	    return fn.call(target);
	  },
	  $shortEq: function $shortEq(target, value, key) {
	    if (_lodash2["default"].isRegExp(value)) {
	      return value.test(target);
	    } else {
	      return value === target;
	    }
	  }
	};

	var arrayOperators = {
	  $in: function $in(target, value) {
	    if (!_lodash2["default"].isArray(value)) throw new _mongo_parsing_error2["default"]("in", "array", value);

	    if (!_lodash2["default"].isArray(target)) {
	      target = [target];
	    }

	    var match = comparisionOperators.$shortEq;

	    for (var i in target) {
	      var curTarget = target[i];
	      for (var j in value) {
	        var curValue = value[j];

	        if (match(curTarget, curValue)) {
	          return true;
	        }
	      }
	    }

	    return false;
	  },
	  $nin: function $nin(target, value) {
	    return !arrayOperators["$in"](target, value);
	  },
	  $all: function $all(target, value) {
	    if (!_lodash2["default"].isArray(value)) throw new _mongo_parsing_error2["default"]("$all", "Array", value);
	    if (!_lodash2["default"].isArray(target)) {
	      target = [target];
	    }
	    return (0, _lodash2["default"])(value).difference(target).isEmpty();
	  },
	  $size: function $size(target, value) {
	    if (!_lodash2["default"].isNumber(value)) throw new _mongo_parsing_error2["default"]("size", "number", value);
	    if (!_lodash2["default"].isArray(target)) return false;

	    return target.length === value;
	  }
	};

	var logicalOperators = {
	  $not: function $not(target, value, key) {
	    var result = whynomatch(target, value);
	    if (_lodash2["default"].isEmpty(result)) return value;else return {};
	  },
	  $or: function $or(target, value, key) {
	    var subQueriesResults = multiOperator(target, value, key);

	    if (subQueriesResults.length === value.length) return value;

	    return {};
	  },
	  $nor: function $nor(target, value, key) {
	    var subQueriesResults = multiOperator(target, value, key);

	    if (subQueriesResults.length !== value.length) return value;

	    return {};
	  },
	  $and: function $and(target, value, key) {
	    var subQueriesResults = multiOperator(target, value, key);

	    if (subQueriesResults.length > 0) return subQueriesResults;

	    return {};
	  },
	  $elemMatch: function $elemMatch(target, value, key) {
	    if (!_lodash2["default"].isPlainObject(value)) throw new _mongo_parsing_error2["default"]("elemMatch", "object", value);

	    if (!_lodash2["default"].isArray(target)) return value;

	    var subQueriesResults = (0, _lodash2["default"])(target).map(_lodash2["default"].partial(whynomatch, _lodash2["default"], value)).reject(_lodash2["default"].partial(_lodash2["default"].isEqual, {})).value();

	    if (subQueriesResults.length === target.length) return value;

	    return {};
	  }
	};

	var virtualOperators = {
	  $nested: function $nested(target, value, key) {
	    var parts = key.split(".");
	    var innerObj = _lodash2["default"].reduce(parts, function (result, value, key) {
	      if (result === undefined) return undefined;

	      return result[value];
	    }, target);

	    return whynomatch(innerObj, value);
	  }
	};

	var operators = _lodash2["default"].extend(logicalOperators, virtualOperators, wrapComperisionOperators(comparisionOperators, true), wrapComperisionOperators(arrayOperators));

	function whynomatch(target, query) {
	  var noMatch = {};

	  if (!_lodash2["default"].isPlainObject(query)) {
	    return operators.$shortEq(target, query);
	  }

	  _lodash2["default"].keys(query).forEach(function (key) {
	    var value = query[key];

	    var operator = getOperator(key, value);
	    var operatorResults = operator(target, value, key);

	    if (!isEmpty(operatorResults)) noMatch[key] = operatorResults;
	  });
	  return noMatch;
	}

	function multiOperator(target, subQueries, key) {
	  if (!_lodash2["default"].isArray(subQueries) || subQueries.length === 0) throw new _mongo_parsing_error2["default"](key, "Array", subQueries);

	  var subQueriesResults = (0, _lodash2["default"])(subQueries).map(_lodash2["default"].partial(whynomatch, target)).reject(_lodash2["default"].partial(_lodash2["default"].isEqual, {})).value();

	  return subQueriesResults;
	}

	function wrapComperisionOperators(operators) {
	  var arrayEquality = arguments[1] === undefined ? false : arguments[1];

	  return _lodash2["default"].transform(operators, function (result, operatorFn, operatorName) {
	    var wrapedOperator = wrapComperisionOperator(operatorFn, arrayEquality);
	    result[operatorName] = wrapedOperator;
	  });
	}

	function wrapComperisionOperator(operatorFn, arrayEquality) {
	  return function (target, value, key) {
	    if (arrayEquality && _lodash2["default"].isArray(target)) {
	      if (!_lodash2["default"].some(target, _lodash2["default"].partial(operatorFn, _lodash2["default"], value, key))) return value;

	      return {};
	    } else if (!operatorFn(target, value, key)) {
	      return value;
	    }

	    return {};
	  };
	}

	function getOperator(key, value) {
	  var operatorName = undefined;

	  if (/^\$.+/.test(key)) {
	    if (key in operators) operatorName = key;else throw new Error(key + " is an unsupported operator");
	  } else {
	    operatorName = "$nested";
	  }

	  return operators[operatorName];
	}

	function isEmpty(value) {
	  return value == undefined || _lodash2["default"].isEqual(value, {});
	}

	exports["default"] = whynomatch;
	module.exports = exports["default"];

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ },
/* 2 */
/***/ function(module, exports) {

	"use strict";

	var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

	var MongoParsingError = (function (_Error) {
	  function MongoParsingError(operator, expected, recived) {
	    _classCallCheck(this, MongoParsingError);

	    var message = operator + " operator must recieve a " + expected + ". Got: " + recived;
	    _get(Object.getPrototypeOf(MongoParsingError.prototype), "constructor", this).call(this, message);
	    this.name = this.constructor.name;
	    this.message = message;
	    Error.captureStackTrace(this, this.constructor.name);
	  }

	  _inherits(MongoParsingError, _Error);

	  return MongoParsingError;
	})(Error);

	module.exports = MongoParsingError;

/***/ }
/******/ ])
});
;